---
title: fit-content()
slug: Web/CSS/fit-content()
tags:
  - CSS
  - CSS Function
  - CSS Grid
  - Function
  - Layout
  - Reference
  - Web
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>fit-content()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Functions">function</a> clamps a given size to an available size according to the formula <code>min(<var>maximum size</var>, max(<var>minimum size</var>, <var>argument</var>))</code>.</span></p>

<div>{{EmbedInteractiveExample("pages/css/function-fit-content.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>The function can be used as a track size in <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">CSS Grid</a> properties, where the maximum size is defined by <code><a href="/en-US/docs/Web/CSS/grid-template-columns#max-content">max-content</a></code> and the minimum size by <code><a href="/en-US/docs/Web/CSS/grid-template-columns#auto">auto</a></code>, which is calculated similar to <code>auto</code> (i.e., <code><a href="/en-US/docs/Web/CSS/minmax">minmax(auto, max-content)</a></code>), except that the track size is clamped at <var>argument</var> if it is greater than the <code>auto</code> minimum.</p>

<p>The function can also be used as laid out box size for {{cssxref("width")}}, {{cssxref("height")}}, {{cssxref("min-width")}}, {{cssxref("min-height")}}, {{cssxref("max-width")}} and {{cssxref("max-height")}}, where the maximum and minimum sizes refer to the content size.</p>

<h2 id="Syntax">Syntax</h2>

<p>The <code>fit-content()</code> function accepts a <code>&lt;length&gt;</code> or a <code>&lt;percentage&gt;</code> as an argument.</p>

<pre class="brush: css no-line-numbers notranslate">/* &lt;length&gt; values */
fit-content(200px)
fit-content(5cm)
fit-content(30vw)
fit-content(100ch)

/* &lt;percentage&gt; value */
fit-content(40%)
</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt>{{cssxref("&lt;length&gt;")}}</dt>
 <dd>An absolute length.</dd>
 <dt>{{cssxref("&lt;percentage&gt;")}}</dt>
 <dd>A percentage relative to the available space in the given axis.</dd>
 <dd>In grid properties it is relative to the inline size of the grid container in column tracks and to the block size of the grid container for row tracks. Otherwise it is relative to the available inline size or block size of the laid out box depending on the writing mode.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Sizing_grid_columns_with_fit-content">Sizing grid columns with fit-content</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div id="container"&gt;
  &lt;div&gt;Item as wide as the content.&lt;/div&gt;
  &lt;div&gt;
    Item with more text in it. Because the contents of it are
    wider than the maximum width, it is clamped at 300 pixels.
  &lt;/div&gt;
  &lt;div&gt;Flexible item&lt;/div&gt;
&lt;/div&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css; highlight[3] notranslate">#container {
  display: grid;
  grid-template-columns: fit-content(300px) fit-content(300px) 1fr;
  grid-gap: 5px;
  box-sizing: border-box;
  height: 200px;
  width: 100%;
  background-color: #8cffa0;
  padding: 10px;
}

#container &gt; div {
  background-color: #8ca0ff;
  padding: 5px;
}
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Sizing_grid_columns_with_fit-content", "100%", 200)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS3 Sizing", "#valdef-width-fit-content-length-percentage", "fit-content()")}}</td>
   <td>{{Spec2("CSS3 Sizing")}}</td>
   <td>Defines the function as laid out box size for {{cssxref("width")}}, {{cssxref("height")}}, {{cssxref("min-width")}}, {{cssxref("min-height")}}, {{cssxref("max-width")}} and {{cssxref("max-height")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName("CSS Grid", "#valdef-grid-template-columns-fit-content", "fit-content()")}}</td>
   <td>{{Spec2("CSS Grid")}}</td>
   <td>Defines the function when used as a track size.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="Supported_for_width_and_other_sizing_properties">Supported for width (and other sizing properties)</h3>

<p>{{Compat("css.properties.width.fit-content-function")}}</p>

<h3 id="Supported_in_grid_layout">Supported in grid layout</h3>

<p>{{Compat("css.properties.grid-template-columns.fit-content")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Related sizing keywords: {{cssxref("min-content")}}, {{cssxref("max-content")}} </li>
 <li>Related CSS Grid properties: {{cssxref("grid-template")}}, {{cssxref("grid-template-rows")}}, {{cssxref("grid-template-columns")}}, {{cssxref("grid-template-areas")}}, {{cssxref("grid-auto-columns")}}, {{cssxref("grid-auto-rows")}}, {{cssxref("grid-auto-flow")}}</li>
 <li>Grid Layout Guide: <em><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Line-based_Placement_with_CSS_Grid">Line-based placement with CSS Grid</a></em></li>
 <li>Grid Layout Guide: <em><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Grid_Template_Areas#Grid_definition_shorthands">Grid template areas - Grid definition shorthands</a></em></li>
</ul>
